Index: TWiki/Attach.pm
===================================================================
--- TWiki/Attach.pm	(revision 13172)
+++ TWiki/Attach.pm	(working copy)
@@ -44,17 +44,15 @@
 
 =pod
 
----++ ClassMethod new( $session )
+---++ ClassMethod new()
 
 Constructor
 
 =cut
 
 sub new {
-    my ( $class, $session ) = @_;
+    my ( $class ) = @_;
     my $this = bless( {}, $class );
-    ASSERT($session->isa( 'TWiki')) if DEBUG;
-    $this->{session} = $session;
     return $this;
 }
 
@@ -84,7 +82,7 @@
 	my @attachments = $meta->find( 'FILEATTACHMENT' );
     return '' unless @attachments;
 
-    my $templates = $this->{session}->{templates};
+    my $templates = $TWiki::TEMPLATES->{templates};
     $templates->readTemplate($tmplname);
 
 	my $rows = '';
@@ -125,11 +123,11 @@
     my( $this, $web, $topic, %attrs ) = @_;
     ASSERT($this->isa( 'TWiki::Attach')) if DEBUG;
 
-    my $store = $this->{session}->{store};
+    my $store = $TWiki::STORE;
     my $latestRev =
       $store->getRevisionNumber( $web, $topic, $attrs{name} );
 
-    my $templates = $this->{session}->{templates};
+    my $templates = $TWiki::TEMPLATES;
     $templates->readTemplate('attachtables');
 
     my $header = $templates->expandTemplate('ATTACH:versions:header');
@@ -183,8 +181,8 @@
         return $info->{version};
     }
     elsif ( $attr eq 'ICON' ) {
-        my $picked = $this->{session}->mapToIconFileName( $file );
-        my $url = $this->{session}->getIconUrl( 0, $picked );
+        my $picked = $TWiki::SESSION->mapToIconFileName( $file );
+        my $url = $TWiki::SESSION->getIconUrl( 0, $picked );
         return CGI::img( { src => $url, width => 16, height=>16,
                            align => 'top',
                            alt => $picked || '',
@@ -197,7 +195,7 @@
         return $1;
     }
     elsif ( $attr eq 'URL' ) {
-        return $this->{session}->getScriptUrl
+        return $TWiki::SESSION->getScriptUrl
           ( 0, 'viewfile', $web, $topic,
             rev => $info->{version} || undef, filename => $file );
     }
@@ -225,7 +223,7 @@
         return TWiki::Time::formatTime( $info->{date} || 0 );
     }
     elsif ( $attr eq 'USER' ) {
-        my $user = $this->{session}->{users}->findUser($info->{user});
+        my $user = $TWiki::USERS->findUser($info->{user});
         if (defined($user)) {
             return $user->webDotWikiName();
         } else {
@@ -261,8 +259,8 @@
 
     my $fileLink = '';
     my $imgSize = '';
-    my $prefs = $this->{session}->{prefs};
-    my $store = $this->{session}->{store};
+    my $prefs = $TWiki::PREFS;
+    my $store = $TWiki::STORE;
 
     if( $attName =~ /\.(gif|jpg|jpeg|png)$/i ) {
         # inline image
@@ -553,7 +551,7 @@
         if( ! $fileUser ) { 
             $fileUser = ''; 
         } else {
-            my $u = $this->{session}->{users}->findUser( $fileUser );
+            my $u = $TWiki::USERS->findUser( $fileUser );
             $fileUser = $u->login() if $u;
         }
         $fileUser =~ s/ //go;
@@ -638,7 +636,7 @@
             $date = TWiki::Time::parseTime( $date );
         }
         $att->{date} = $date;
-        my $u = $this->{session}->{users}->findUser( $att->{user} );
+        my $u = $TWiki::USERS->findUser( $att->{user} );
         $att->{user} = $u->webDotWikiName() if $u;
     }
 }
Index: TWiki/Search.pm
===================================================================
--- TWiki/Search.pm	(revision 13172)
+++ TWiki/Search.pm	(working copy)
@@ -47,19 +47,15 @@
 
 =pod
 
----++ ClassMethod new ($session)
+---++ ClassMethod new()
 
 Constructor for the singleton Search engine object.
 
 =cut
 
 sub new {
-    my ( $class, $session ) = @_;
+    my ( $class ) = @_;
     my $this = bless( {}, $class );
-
-    ASSERT($session->isa( 'TWiki')) if DEBUG;
-    $this->{session} = $session;
-
     return $this;
 }
 
@@ -76,7 +72,7 @@
     # Only well-secured intranet sites, authenticated for all access
     # (view, edit, attach, search, etc), AND forced to use unsafe
     # platforms, should use the $forceUnsafeRegexes flag.
-    my $unsafePlatform = ( not ($this->{session}->{sandbox}->{SAFE} ) );
+    my $unsafePlatform = ( not ($TWiki::SANDBOX->{SAFE} ) );
 
     # FIXME: Use of new global
     my $useFilterIn = ($unsafePlatform and not $TWiki::cfg{ForceUnsafeRegexes});
@@ -195,7 +191,7 @@
         $searchString =~ s/[\+\-]\s+//go;
 
         # Build pattern of stop words
-        my $prefs = $this->{session}->{prefs};
+        my $prefs = $TWiki::PREFS;
         my $stopWords = $prefs->getPreferencesValue( 'SEARCHSTOPWORDS' ) || '';
         $stopWords =~ s/[\s\,]+/\|/go;
         $stopWords =~ s/[\(\)]//go;
@@ -232,7 +228,7 @@
 
     my @topicList = ();
     return @topicList unless( @theTokens );   # bail out if no search string
-    my $store = $this->{session}->{store};
+    my $store = $TWiki::STORE;
 
     if( $topic ) {
         # limit search to topic list
@@ -371,8 +367,8 @@
     my %params = @_;
     my $callback =      $params{_callback};
     my $cbdata =        $params{_cbdata};
-    my $baseTopic =     $params{basetopic} || $this->{session}->{topicName};
-    my $baseWeb =       $params{baseweb}   || $this->{session}->{webName};
+    my $baseTopic =     $params{basetopic} || $TWiki::SESSION->{topicName};
+    my $baseWeb =       $params{baseweb}   || $TWiki::SESSION->{webName};
     my $doBookView =    TWiki::isTrue( $params{bookview} );
     my $caseSensitive = TWiki::isTrue( $params{casesensitive} );
     my $excludeTopic =  $params{excludetopic} || '';
@@ -410,8 +406,7 @@
 
     $baseWeb =~ s/\./\//go;
 
-    my $session = $this->{session};
-    my $renderer = $session->{renderer};
+    my $renderer = $TWiki::RENDER;
 
     # Limit search results
     if ($limit =~ /(^\d+$)/o) {
@@ -440,9 +435,9 @@
     }
 
     my $searchResult = '';
-    my $homeWeb = $session->{webName};
+    my $homeWeb = $TWiki::SESSION->{webName};
     my $homeTopic = $TWiki::cfg{HomeTopicName};
-    my $store = $session->{store};
+    my $store = $TWiki::STORE;
 
     my %excludeWeb;
     my @tmpWebs;
@@ -470,10 +465,10 @@
 
     } else {
         # default to current web
-        push( @tmpWebs, $session->{webName} );
+        push( @tmpWebs, $TWiki::SESSION->{webName} );
         if ( TWiki::isTrue( $recurse )) {
-            push( @tmpWebs, $store->getListOfWebs( 'user,allowed',
-                                                   $session->{webName} ));
+            push( @tmpWebs, $store->getListOfWebs(
+                'user,allowed', $TWiki::SESSION->{webName} ));
         }
     }
 
@@ -504,7 +499,7 @@
     } else {
         $template = 'search';
     }
-    $tmpl = $session->{templates}->readTemplate( $template );
+    $tmpl = $TWiki::TEMPLATES->readTemplate( $template );
 
     # SMELL: the only META tags in a template will be METASEARCH
     # Why the heck are they being filtered????
@@ -528,16 +523,16 @@
     }
 
     # Expand tags in template sections
-    $tmplSearch = $session->handleCommonTags( $tmplSearch,
+    $tmplSearch = $TWiki::SESSION->handleCommonTags( $tmplSearch,
                                               $homeWeb,
                                               $homeTopic );
-    $tmplNumber = $session->handleCommonTags( $tmplNumber,
+    $tmplNumber = $TWiki::SESSION->handleCommonTags( $tmplNumber,
                                               $homeWeb,
                                               $homeTopic );
 
     # If not inline search, also expand tags in head and tail sections
     unless( $inline ) {
-        $tmplHead = $session->handleCommonTags( $tmplHead,
+        $tmplHead = $TWiki::SESSION->handleCommonTags( $tmplHead,
                                                 $homeWeb,
                                                 $homeTopic );
 
@@ -583,11 +578,11 @@
     # FIXME: Move log entry further down to log actual webs searched
     if( ( $TWiki::cfg{Log}{search} ) && ( ! $inline ) ) {
         my $t = join( ' ', @webs );
-        $session->writeLog( 'search', $t, $searchString );
+        $TWiki::SESSION->writeLog( 'search', $t, $searchString );
     }
 
     # Loop through webs
-    my $isAdmin = $session->{user}->isAdmin();
+    my $isAdmin = $TWiki::SESSION->{user}->isAdmin();
     my $ttopics = 0;
     foreach my $web ( @webs ) {
         $web =~ s/$TWiki::cfg{NameFilter}//go;
@@ -595,7 +590,7 @@
 
         next unless $store->webExists( $web );  # can't process what ain't thar
 
-        my $prefs = $session->{prefs};
+        my $prefs = $TWiki::PREFS;
         my $thisWebNoSearchAll = $prefs->getWebPreferencesValue( 'NOSEARCHALL', $web ) || '';
 
         # make sure we can report this web on an 'all' search
@@ -603,7 +598,7 @@
         next if ( $searchAllFlag
                   && ! $isAdmin
                   && ( $thisWebNoSearchAll =~ /on/i || $web =~ /^[\.\_]/ )
-                  && $web ne $session->{webName} );
+                  && $web ne $TWiki::SESSION->{webName} );
 
         # Run the search on topics in this web
         my @topicList = $this->_searchTopicsInWeb(
@@ -713,7 +708,7 @@
             my $isoDate = TWiki::Time::formatTime( $epochSecs, '$iso', 'gmtime');
 
             my $revUser = $topicInfo->{$topic}->{editby} || 'UnknownUser';
-            my $ru = $session->{users}->findUser( $revUser );
+            my $ru = $TWiki::USERS->findUser( $revUser );
             my $revNum  = $topicInfo->{$topic}->{revNum} || 0;
 
             # Check security
@@ -734,7 +729,7 @@
                         # primitive way to prevent recursion
                         $text =~ s/%SEARCH/%<nop>SEARCH/g;
                     }
-                    $text = $session->handleCommonTags(
+                    $text = $TWiki::SESSION->handleCommonTags(
                         $text, $web, $topic, $meta );
                 }
             }
@@ -780,7 +775,7 @@
                     $out =~ s/\$createwikiusername/$this->_getRev1Info( $web, $topic, 'wikiusername', $r1info )/ges;
                     if( $out =~ m/\$text/ ) {
                         ( $meta, $text ) = $this->_getTextAndMeta( $topicInfo, $web, $topic ) unless $text;
-                        if( $topic eq $session->{topicName} ) {
+                        if( $topic eq $TWiki::SESSION->{topicName} ) {
                             # defuse SEARCH in current topic to prevent loop
                             $text =~ s/%SEARCH{.*?}%/SEARCH{...}/go;
                         }
@@ -796,7 +791,7 @@
 
                 my $srev = 'r' . $revNum;
                 if( $revNum eq '0' || $revNum eq '1' ) {
-                    $srev = CGI::span( { class => 'twikiNew' }, ($this->{session}->{i18n}->maketext('NEW')) );
+                    $srev = CGI::span( { class => 'twikiNew' }, ($TWiki::I18N->maketext('NEW')) );
                 }
                 $out =~ s/%REVISION%/$srev/o;
                 $out =~ s/%AUTHOR%/$revUser/o;
@@ -809,9 +804,9 @@
                         # primitive way to prevent recursion
                         $text =~ s/%SEARCH/%<nop>SEARCH/g;
                     }
-                    $text = $session->handleCommonTags(
+                    $text = $TWiki::SESSION->handleCommonTags(
                         $text, $web, $topic, $meta );
-                    $text = $session->{renderer}->getRenderedVersion
+                    $text = $TWiki::RENDER->getRenderedVersion
                       ( $text, $web, $topic );
                     # FIXME: What about meta data rendering?
                     $out =~ s/%TEXTHEAD%/$text/go;
@@ -854,13 +849,13 @@
                 # lazy output of header (only if needed for the first time)
                 unless( $headerDone ) {
                     $headerDone = 1;
-                    my $prefs = $session->{prefs};
+                    my $prefs = $TWiki::PREFS;
                     my $thisWebBGColor =
                       $prefs->getWebPreferencesValue( 'WEBBGCOLOR', $web ) ||
                         '\#FF00FF';
                     $beforeText =~ s/%WEBBGCOLOR%/$thisWebBGColor/go;
                     $beforeText =~ s/%WEB%/$web/go;
-                    $beforeText = $session->handleCommonTags(
+                    $beforeText = $TWiki::SESSION->handleCommonTags(
                         $beforeText, $web, $topic );
                     if ( defined $callback ) {
                         $beforeText =
@@ -901,7 +896,7 @@
         # output footer only if hits in web
         if( $ntopics ) {
             # output footer of $web
-            $afterText  = $session->handleCommonTags(
+            $afterText  = $TWiki::SESSION->handleCommonTags(
                 $afterText, $web, $homeTopic );
             if( $inline || $format ) {
                 $afterText =~ s/\n$//os;  # remove trailing new line
@@ -949,7 +944,7 @@
     }
 
     unless( $inline ) {
-        $tmplTail = $session->handleCommonTags( $tmplTail,
+        $tmplTail = $TWiki::SESSION->handleCommonTags( $tmplTail,
                                                 $homeWeb,
                                                 $homeTopic );
 
@@ -967,7 +962,7 @@
     return undef if ( defined $callback );
     return $searchResult if $inline;
 
-    $searchResult = $session->handleCommonTags( $searchResult,
+    $searchResult = $TWiki::SESSION->handleCommonTags( $searchResult,
                                                 $homeWeb,
                                                 $homeTopic );
     $searchResult = $renderer->getRenderedVersion( $searchResult,
@@ -1017,8 +1012,7 @@
 sub _extractTopicInfo {
     my ( $this, $web, $topic, $sortfield ) = @_;
     my $info = {};
-    my $session = $this->{session};
-    my $store = $session->{store};
+    my $store = $TWiki::STORE;
 
     my ( $meta, $text ) = $this->_getTextAndMeta( undef, $web, $topic );
 
@@ -1031,10 +1025,10 @@
     $info->{revNum}     = $revnum;
 
     $info->{allowView} =
-      $session->{security}->
-        checkAccessPermission( 'VIEW', $session->{user},
-                               $text, $meta,
-                               $topic, $web );
+      $TWiki::ACCESS->checkAccessPermission(
+          'VIEW', $TWiki::SESSION->{user},
+          $text, $meta,
+          $topic, $web );
 
     return $info unless $sortfield;
 
@@ -1051,7 +1045,7 @@
 sub _getTextAndMeta {
     my( $this, $topicInfo, $web, $topic ) = @_;
     my ( $meta, $text );
-    my $store = $this->{session}->{store};
+    my $store = $TWiki::STORE;
 
     # read from cache if it's there
     if ( $topicInfo ) {
@@ -1075,10 +1069,10 @@
 sub _getRev1Info {
     my( $this, $web, $topic, $attr, $info ) = @_;
     my $key = $web.'.'.$topic;
-    my $store = $this->{session}->{store};
+    my $store = $TWiki::STORE;
 
     unless( $info->{webTopic} && $info->{webTopic} eq $key ) {
-        my $meta = new TWiki::Meta( $this->{session}, $web, $topic );
+        my $meta = new TWiki::Meta( $web, $topic );
         my ( $d, $u ) = $meta->getRevisionInfo( 1 );
         $info->{date} = $d;
         $info->{user} = $u;
Index: TWiki/Compatibility.pm
===================================================================
--- TWiki/Compatibility.pm	(revision 13172)
+++ TWiki/Compatibility.pm	(working copy)
@@ -112,7 +112,7 @@
 
 =pod
 
----++ StaticMethod upgradeCategoryTable( $session, $web, $topic, $meta, $text ) -> $text
+---++ StaticMethod upgradeCategoryTable( $web, $topic, $meta, $text ) -> $text
 
 Upgrade old style category table
 
@@ -121,9 +121,9 @@
 =cut
 
 sub upgradeCategoryTable {
-    my( $session, $web, $topic, $meta, $text ) = @_;
+    my( $web, $topic, $meta, $text ) = @_;
 
-    my $icat = $session->{templates}->readTemplate( 'twikicatitems' );
+    my $icat = $TWiki::TEMPLATES->readTemplate( 'twikicatitems' );
 
     if( $icat ) {
         my @items = ();
@@ -141,7 +141,7 @@
                 push @items, ( [$catname, $catmod, $catvalue] );
             }
         }
-        my $prefs = $session->{prefs};
+        my $prefs = $TWiki::PREFS;
         my $listForms = $prefs->getWebPreferencesValue( 'WEBFORMS', $web );
         $listForms =~ s/^\s*//go;
         $listForms =~ s/\s*$//go;
@@ -150,7 +150,7 @@
         $defaultFormTemplate = $formTemplates[0] if ( @formTemplates );
 
         if( ! $defaultFormTemplate ) {
-            $session->writeWarning( "Form: can't get form definition to convert category table " .
+            $TWiki::SESSION->writeWarning( "Form: can't get form definition to convert category table " .
                                   " for topic $web.$topic" );
             foreach my $oldCat ( @items ) {
                 my $name = $oldCat->[0];
@@ -165,7 +165,7 @@
             return;
         }
 
-        my $def = new TWiki::Form($session, $web, $defaultFormTemplate );
+        my $def = new TWiki::Form( $web, $defaultFormTemplate );
         $meta->put( 'FORM', { name => $defaultFormTemplate } );
 
         foreach my $fieldDef ( @{$def->{fields}} ) {
@@ -188,7 +188,7 @@
         }
 
     } else {
-        $session->writeWarning( "Form: get find category template twikicatitems for Web $web" );
+        $TWiki::SESSION->writeWarning( "Form: get find category template twikicatitems for Web $web" );
     }
     return $text;
 }
Index: TWiki/Upgrade/MoveTopics.pm
===================================================================
--- TWiki/Upgrade/MoveTopics.pm	(revision 13172)
+++ TWiki/Upgrade/MoveTopics.pm	(working copy)
@@ -23,7 +23,7 @@
 sub moveTopics {
 my ( $session ) = @_;
 
-	if (! $session->{store}->webExists('TWikiConfiguration') ) {
+	if (! $TWiki::STORE->webExists('TWikiConfiguration') ) {
 		my $opts =
 		{
 			WEBBGCOLOR => '#C0FFFF',
@@ -32,11 +32,11 @@
 			NOSEARCHALL => '',
 		};
 		$opts->{SITEMAPLIST} = "on" if( $opts->{SITEMAPWHAT} );
-	    my $err = $session->{store}->createWeb( $session->{user},
+	    my $err = $TWiki::STORE->createWeb( $session->{user},
                                                 'TWikiConfiguration',
                                                 '_default', $opts);
 	}
-	if (! $session->{store}->webExists('TWikiDocumentation') ) {
+	if (! $TWiki::STORE->webExists('TWikiDocumentation') ) {
 		my $opts =
 		{
 			WEBBGCOLOR => '#C0C0C0',
@@ -45,11 +45,11 @@
 			NOSEARCHALL => '',
 		};
 		$opts->{SITEMAPLIST} = "on" if( $opts->{SITEMAPWHAT} );
-	    my $err = $session->{store}->createWeb( $session->{user},
+	    my $err = $TWiki::STORE->createWeb( $session->{user},
                                                 'TWikiDocumentation',
                                                 '_default', $opts );
 	}
-	if (! $session->{store}->webExists('TWikiUsers') ) {
+	if (! $TWiki::STORE->webExists('TWikiUsers') ) {
 		my $opts =
 		{
 			WEBBGCOLOR => '#C0C0FF',
@@ -58,7 +58,7 @@
 			NOSEARCHALL => '',
 		};
 		$opts->{SITEMAPLIST} = "on" if( $opts->{SITEMAPWHAT} );
-	    my $err = $session->{store}->createWeb( $session->{user},
+	    my $err = $TWiki::STORE->createWeb( $session->{user},
                                                 'TWikiUsers',
                                                 '_default', $opts );
 	}
@@ -310,8 +310,7 @@
                                                      $oldWeb, $oldTopic,
                                                      $newWeb);
     # SMELL: this may throw a TWiki::OopsException if there is an error
-    TWiki::UI::Manage::move( $session,
-                             $oldWeb, $oldTopic,
+    TWiki::UI::Manage::move( $oldWeb, $oldTopic,
                              $newWeb, $newTopic,
                              undef, $refs );
 }
Index: TWiki/UI.pm
===================================================================
--- TWiki/UI.pm	(revision 13172)
+++ TWiki/UI.pm	(working copy)
@@ -151,31 +151,31 @@
         }
     }
 
-    my $session = new TWiki( $user, $query, \%initialContext );
+    local $TWiki::SESSION = new TWiki( $user, $query, \%initialContext );
 
     local $SIG{__DIE__} = \&Carp::confess;
 
     try {
-        $session->{loginManager}->checkAccess();
-        &$method( $session );
+        $TWiki::LOGIN->checkAccess();
+        &$method( );
     } catch TWiki::AccessControlException with {
         my $e = shift;
-        unless( $session->{loginManager}->forceAuthentication() ) {
+        unless( $TWiki::LOGIN->forceAuthentication() ) {
             # Client did not want to authenticate, perhaps because
             # we are already authenticated.
-            my $url = $session->getOopsUrl('accessdenied',
+            my $url = $TWiki::SESSION->getOopsUrl('accessdenied',
                                        def => 'topic_access',
                                        web => $e->{web},
                                        topic => $e->{topic},
                                        params => [ $e->{mode},
                                                    $e->{reason} ]);
-            $session->redirect( $url, 1 );
+            $TWiki::SESSION->redirect( $url, 1 );
         }
 
     } catch TWiki::OopsException with {
         my $e = shift;
-        my $url = $session->getOopsUrl( $e );
-        $session->redirect( $url, $e->{keep} );
+        my $url = $TWiki::SESSION->getOopsUrl( $e );
+        $TWiki::SESSION->redirect( $url, $e->{keep} );
 
     } catch Error::Simple with {
         my $e = shift;
@@ -186,7 +186,7 @@
         } else {
             my $mess = $e->stringify();
             print STDERR $mess;
-            $session->writeWarning( $mess );
+            $TWiki::SESSION->writeWarning( $mess );
             # tell the browser where to look for more help
             print 'TWiki detected an internal error - please check your TWiki logs and webserver logs for more information.'."\n\n";
             $mess =~ s/ at .*$//s;
@@ -199,12 +199,12 @@
         print "Unspecified error";
     };
 
-    $session->finish();
+    $TWiki::SESSION->finish();
 }
 
 =pod twiki
 
----++ StaticMethod checkWebExists( $session, $web, $topic, $op )
+---++ StaticMethod checkWebExists( $web, $topic, $op )
 
 Check if the web exists. If it doesn't, will throw an oops exception.
  $op is the user operation being performed.
@@ -212,10 +212,9 @@
 =cut
 
 sub checkWebExists {
-    my ( $session, $webName, $topic, $op ) = @_;
-    ASSERT($session->isa( 'TWiki')) if DEBUG;
+    my ( $webName, $topic, $op ) = @_;
 
-    unless ( $session->{store}->webExists( $webName ) ) {
+    unless ( $TWiki::STORE->webExists( $webName ) ) {
         throw
           TWiki::OopsException( 'accessdenied',
                                 def => 'no_such_web',
@@ -227,7 +226,7 @@
 
 =pod
 
----++ StaticMethod topicExists( $session, $web, $topic, $op ) => boolean
+---++ StaticMethod checkTopicExists( $web, $topic, $op ) => boolean
 
 Check if the given topic exists, throwing an OopsException
 if it doesn't. $op is the user operation being performed.
@@ -235,10 +234,9 @@
 =cut
 
 sub checkTopicExists {
-    my ( $session, $webName, $topic, $op ) = @_;
-    ASSERT($session->isa( 'TWiki')) if DEBUG;
+    my ( $webName, $topic, $op ) = @_;
 
-    unless( $session->{store}->topicExists( $webName, $topic )) {
+    unless( $TWiki::STORE->topicExists( $webName, $topic )) {
         throw TWiki::OopsException( 'accessdenied',
                                     def => 'no_such_topic',
                                     web => $webName,
@@ -249,31 +247,6 @@
 
 =pod twiki
 
----++ StaticMethod checkMirror( $session, $web, $topic )
-
-Checks if this web is a mirror web, throwing an OopsException
-if it is.
-
-=cut
-
-sub checkMirror {
-    my ( $session, $webName, $topic ) = @_;
-    ASSERT($session->isa( 'TWiki')) if DEBUG;
-
-    my( $mirrorSiteName, $mirrorViewURL ) =
-      $session->readOnlyMirrorWeb( $webName );
-
-    return unless ( $mirrorSiteName );
-
-    throw TWiki::OopsException( 'mirror',
-                                web => $webName,
-                                topic => $topic,
-                                params => [ $mirrorSiteName,
-                                            $mirrorViewURL ] );
-}
-
-=pod twiki
-
 ---++ StaticMethod checkAccess( $web, $topic, $mode, $user )
 
 Check if the given mode of access by the given user to the given
@@ -282,10 +255,9 @@
 =cut
 
 sub checkAccess {
-    my ( $session, $web, $topic, $mode, $user ) = @_;
-    ASSERT($session->isa( 'TWiki')) if DEBUG;
+    my ( $web, $topic, $mode, $user ) = @_;
 
-    unless( $session->{security}->checkAccessPermission(
+    unless( $TWiki::ACCESS->checkAccessPermission(
         $mode, $user, undef, undef, $topic, $web )) {
         throw TWiki::OopsException( 'accessdenied',
                                     def => 'topic_access',
@@ -293,32 +265,31 @@
                                     topic => $topic,
                                     params =>
                                     [ $mode,
-                                      $session->{security}->getReason()]);
+                                      $TWiki::ACCESS->getReason()]);
     }
 }
 
 =pod
 
----++ StaticMethod readTemplateTopic( $session, $theTopicName ) -> ( $meta, $text )
+---++ StaticMethod readTemplateTopic( $theTopicName ) -> ( $meta, $text )
 
-Read a topic from the TWiki web, or if that fails from the current
+!Read a topic from the TWiki web, or if that fails from the current
 web.
 
 =cut
 
 sub readTemplateTopic {
-    my( $session, $theTopicName ) = @_;
-    ASSERT($session->isa( 'TWiki')) if DEBUG;
+    my( $theTopicName ) = @_;
 
     $theTopicName =~ s/$TWiki::cfg{NameFilter}//go;
 
     my $web = $TWiki::cfg{SystemWebName};
-    if( $session->{store}->topicExists( $session->{webName}, $theTopicName )) {
+    if( $TWiki::STORE->topicExists( $TWiki::SESSION->{webName}, $theTopicName )) {
         # try to read from current web, if found
-        $web = $session->{webName};
+        $web = $TWiki::SESSION->{webName};
     }
-    return $session->{store}->readTopic(
-        $session->{user}, $web, $theTopicName, undef );
+    return $TWiki::STORE->readTopic(
+        $TWiki::SESSION->{user}, $web, $theTopicName, undef );
 }
 
 1;
Index: TWiki/User.pm
===================================================================
--- TWiki/User.pm	(revision 13172)
+++ TWiki/User.pm	(working copy)
@@ -53,7 +53,7 @@
 
 =pod
 
----++ ClassMethod new( $session, $loginname, $wikiname )
+---++ ClassMethod new( $loginname, $wikiname )
 
 Construct a new user object for the given login name, wiki name.
 
@@ -65,17 +65,15 @@
 =cut
 
 sub new {
-    my( $class, $session, $name, $wikiname ) = @_;
-    ASSERT($session->isa( 'TWiki')) if DEBUG;
+    my( $class, $name, $wikiname ) = @_;
     ASSERT($name) if DEBUG;
     ASSERT($wikiname) if DEBUG;
 
     my $this = bless( {}, $class );
-    $this->{session} = $session;
 
     $this->{login} = $name;
-    my( $web, $topic ) =
-      $session->normalizeWebTopicName( $TWiki::cfg{UsersWebName}, $wikiname );
+    my( $web, $topic ) = $TWiki::SESSION->normalizeWebTopicName(
+        $TWiki::cfg{UsersWebName}, $wikiname );
     $this->{web} = $web;
     $this->{wikiname} = $topic;
     $this->{groups} = [];
@@ -182,7 +180,7 @@
     my $this  = shift;
     ASSERT($this->isa( 'TWiki::User')) if DEBUG;
 
-    my $passwordHandler = $this->{session}->{users}->{passwords};
+    my $passwordHandler = $TWiki::USERS->{passwords};
     return $passwordHandler->fetchPass($this->{login});
 }
 
@@ -204,7 +202,7 @@
     my ( $this, $password ) = @_;
     ASSERT($this->isa( 'TWiki::User')) if DEBUG;
 
-    my $passwordHandler = $this->{session}->{users}->{passwords};
+    my $passwordHandler = $TWiki::USERS->{passwords};
     return $passwordHandler->checkPassword($this->{login}, $password);
 }
 
@@ -223,7 +221,7 @@
     my $this = shift;
     ASSERT($this->isa( 'TWiki::User')) if DEBUG;
 
-    my $passwordHandler = $this->{session}->{users}->{passwords};
+    my $passwordHandler = $TWiki::USERS->{passwords};
     return $passwordHandler->deleteUser( $this->{login} );
 }
 
@@ -242,7 +240,7 @@
     my ( $this, $oldUserPassword, $newUserPassword ) = @_;
     ASSERT($this->isa( 'TWiki::User')) if DEBUG;
 
-    my $passwordHandler = $this->{session}->{users}->{passwords};
+    my $passwordHandler = $TWiki::USERS->{passwords};
     if( $passwordHandler->passwd($this->{login},
                                  $newUserPassword, $oldUserPassword)) {
         return undef;
@@ -266,7 +264,7 @@
     my ( $this, $newUserPassword ) = @_;
     ASSERT($this->isa( 'TWiki::User')) if DEBUG;
 
-    my $passwordHandler = $this->{session}->{users}->{passwords};
+    my $passwordHandler = $TWiki::USERS->{passwords};
     return $passwordHandler->passwd($this->{login}, $newUserPassword);
 }
 
@@ -324,7 +322,7 @@
                 push( @{$this->{emails}}, $it->next()->emails() );
             }
         } else {
-            my $passwordHandler = $this->{session}->{users}->{passwords};
+            my $passwordHandler = $TWiki::USERS->{passwords};
             push(@{$this->{emails}}, $passwordHandler->getEmails($this->{login}));
         }
     }
@@ -344,7 +342,7 @@
     my $this = shift;
     ASSERT($this->isa( 'TWiki::User')) if DEBUG;
     return if $this->isGroup();
-    my $passwordHandler = $this->{session}->{users}->{passwords};
+    my $passwordHandler = $TWiki::USERS->{passwords};
     return $passwordHandler->setEmails($this->{login}, @_);
 }
 
@@ -364,7 +362,7 @@
         if ($this->{wikiname} eq $TWiki::cfg{SuperAdminGroup}) {
             $this->{isKnownAdmin} = 1;
         } else {
-            my $sag = $this->{session}->{users}->findUser(
+            my $sag = $TWiki::USERS->findUser(
                  $TWiki::cfg{SuperAdminGroup} );
             $this->{isKnownAdmin} = $this->isInGroup( $sag );
         }
@@ -384,8 +382,8 @@
     my $this = shift;
     ASSERT($this->isa( 'TWiki::User')) if DEBUG;
     return $this->{groups} if defined($this->{groups});
-    my $users = $this->{session}->{users};
-    my $it = $this->{session}->{users}->eachGroup();
+    my $users = $TWiki::USERS->{users};
+    my $it = $TWiki::USERS->eachGroup();
     while ($it->hasNext()) {
         my $groupObject = $it->next();
         my $it = $groupObject->eachGroupMember();
@@ -414,7 +412,7 @@
 
     unless( ref( $userlist )) {
         # string parameter
-        $userlist = $this->{session}->{users}->expandUserList( $userlist );
+        $userlist = $TWiki::USERS->expandUserList( $userlist );
     }
     my $user;
     foreach $user ( @$userlist ) {
@@ -443,7 +441,7 @@
 
     return 1 if $this->{wikiname} eq $TWiki::cfg{SuperAdminGroup};
 
-    return $this->{session}->{users}->isGroup($this);
+    return $TWiki::USERS->isGroup($this);
 }
 
 =pod
@@ -458,7 +456,7 @@
 sub eachGroupMember {
     my $this = shift;
     ASSERT($this->isGroup()) if DEBUG;
-    return $this->{session}->{users}->eachGroupMember($this);
+    return $TWiki::USERS->eachGroupMember($this);
 }
 
 =pod
@@ -472,7 +470,7 @@
 sub eachMembership {
     my $this = shift;
 
-    return $this->{session}->{users}->eachMembership($this);
+    return $TWiki::USERS->eachMembership($this);
 }
 
 =pod
@@ -485,7 +483,7 @@
 
 sub isInGroup {
     my( $this, $group ) = @_;
-    return $this->{session}->{users}->isInGroup( $this, $group );
+    return $TWiki::USERS->isInGroup( $this, $group );
 }
 
 1;
